#!/usr/bin/python
# -*- coding: utf8 -*-
import wx
##########################################################
##
##  		traitement des score
##
##########################################################
class fen_score(wx.Frame):
	def __init__ ( self, titre):
		self. d_score = {}		# contient les infos du bloc score
		self.l_port = []			# liste des dicos du bloc Staff
		self.l_score = []			# liste des dicos score à retourner
		x = 0	# placement des cellules sur la grille
		y = 0
		wx.Frame.__init__(self, None, wx.ID_ANY, title = titre, pos = (300,300) )		# création 
		grille = wx.GridBagSizer()		# création de la grille type tableur : accès direct aux cellules
		self.t_nom = wx.TextCtrl(self, wx.ID_ANY, 'score' )		# champ de saisie
		e_nom = wx.StaticText(self, wx.ID_ANY, "nom " )	# etiquette associée
		self.t_type = wx.TextCtrl(self, wx.ID_ANY, "ChoirStaff")
		e_type = wx.StaticText(self, wx.ID_ANY, "type : " )
		self.t_tempo = wx.TextCtrl(self, wx.ID_ANY, '4/4' )
		e_tempo = wx.StaticText(self, wx.ID_ANY, "tempo" )	# etiquette associée
		self.t_armature = wx.TextCtrl(self, wx.ID_ANY, "do")
		e_armature = wx.StaticText(self, wx.ID_ANY, "tonalité (majeur) : " )
		self.t_vitesse = wx.TextCtrl(self, wx.ID_ANY, '4 = 80' )
		e_vitesse = wx.StaticText(self, wx.ID_ANY, "vitesse" )	# etiquette associée

		b_score_ok = wx.Button(self, wx.ID_ANY , "OK")
		b_portee = wx.Button(self, wx.ID_ANY , "Ajout Portée")
		b_fermer = wx.Button(self, wx.ID_ANY , "Fermer")
		self.Bind( wx.EVT_BUTTON, self.b_score_ok_clic, b_score_ok)
		self.Bind( wx.EVT_BUTTON, self.b_portee_clic, b_portee)
		self.Bind( wx.EVT_BUTTON, self.b_fermer_clic, b_fermer)
	
		grille.Add(e_nom, (x,y), (1,1), wx.EXPAND )
		grille.Add (self.t_nom, (x,y+1) , (1,1) , wx.EXPAND )	# ajout des champs  : objet, où (L, C), extension (nb L, nb C), formatage
		x += 1
		grille.Add(e_type, (x,y), (1,1), wx.EXPAND )
		grille.Add(self.t_type, (x,y+1), (1,1), wx.EXPAND )
		x += 1
		grille.Add(e_tempo, (x,y), (1,1), wx.EXPAND )
		grille.Add(self.t_tempo, (x,y+1), (1,1), wx.EXPAND )
		x += 1
		grille.Add(e_vitesse, (x,y), (1,1), wx.EXPAND )
		grille.Add(self.t_vitesse, (x,y+1), (1,1), wx.EXPAND )
		x += 1
		grille.Add(e_armature, (x,y), (1,1), wx.EXPAND )
		grille.Add(self.t_armature, (x,y+1), (1,1), wx.EXPAND )
		x += 2
		grille.Add(b_portee, (x, 0), (1, 1))
		grille.Add(b_fermer, (x, 1), (1, 1))
		grille.Add(b_score_ok, (x, 2), (1, 1))
		grille.AddGrowableCol(1)	
		self.SetSizerAndFit(grille)		# mise en place finale
		self.Show(True)					# et affichage
		
	def b_score_ok_clic(self, ev_b_score_ok):		# fin de l'ajout d'un nouveau bloc score
		self.d_score ['nom'] = self.t_nom.GetValue()
		self.d_score ['type'] = self.t_type.GetValue()
		self.d_score ['armature'] = self.t_armature.GetValue()
		self.d_score ['tempo'] = self.t_tempo.GetValue()
		self.d_score ['vitesse'] = self.t_vitesse.GetValue()
		self.d_score ['liste_dp'] = self.l_port		# #################################" 
		self.Destroy()
##		return self.l_score
#		return True
		
	def b_portee_clic(self, ev_b_portee):
		self.fenetre_portee = fen_portee("Portée")
		self.l_port.append ( self.fenetre_portee.lit_portee() )
		return True
		
	def b_fermer_clic(self, ev_b_fermer):
		self.Destroy()
		
	def lit_part(self ):		# réellement ici ou dans le b_score_ok ?
		return self.d_score
		
##########################################################
##
##  		traitement des portées (Staff)
##
##########################################################
		
class fen_portee(wx.Frame):
	def __init__ ( self, titre):
		self. d_port = {}
		self.l_port = []		# liste des portées à retourner
		self.l_voix = []		# liste des voix associées à la portée
		x = 0	# placement des cellules sur la grille
		y = 0
		wx.Frame.__init__(self, None, wx.ID_ANY, title = titre, pos = ( 250, 250 ) )		# création 
		grille = wx.GridBagSizer()		# création de la grille type tableur : accès direct aux cellules
		self.t_portee = wx.TextCtrl(self, wx.ID_ANY, 'Portée', size=(150, 30) )		# champ de saisie
		e_portee = wx.StaticText(self, wx.ID_ANY, "nom " )	# etiquette associée
		self.t_clef = wx.TextCtrl(self, wx.ID_ANY, "violin")
		e_clef = wx.StaticText(self, wx.ID_ANY, "Clef" )
		self.t_instrum = wx.TextCtrl(self, wx.ID_ANY, "violon" )
		e_instrum = wx.StaticText(self, wx.ID_ANY, "Instrument : " )
		self.t_instr = wx.TextCtrl(self, wx.ID_ANY, "S")
		e_instr = wx.StaticText(self, wx.ID_ANY, "Instr : " )
		self.t_instr_midi = wx.TextCtrl(self, wx.ID_ANY, "midi")
		e_instr_midi = wx.StaticText(self, wx.ID_ANY, "Instr midi : " )
		b_portee_ok = wx.Button(self, wx.ID_ANY , "OK")
		b_voix = wx.Button(self, wx.ID_ANY , "Ajout voix")
		b_fermer = wx.Button(self, wx.ID_ANY , "Fermer")
		self.Bind( wx.EVT_BUTTON, self.b_portee_ok_clic, b_portee_ok)
		self.Bind( wx.EVT_BUTTON, self.b_voix_clic, b_voix)
		self.Bind( wx.EVT_BUTTON, self.b_fermer_clic, b_fermer)
	
		grille.Add(e_portee, (x,y), (1,1), wx.EXPAND )
		grille.Add (self.t_portee, (x,y+1) , (1,1) , wx.EXPAND )	# ajout des champs  : objet, où (L, C), extension (nb L, nb C), formatage
		x += 1
		grille.Add(e_clef, (x,y), (1,1), wx.EXPAND )
		grille.Add(self.t_clef, (x,y+1), (1,1), wx.EXPAND )
		x += 1
		grille.Add(e_instrum, (x,y), (1,1), wx.EXPAND )
		grille.Add ( self.t_instrum, (x, y+1), (1, 1), wx.EXPAND )
		x += 1
		grille.Add(e_instr, (x,y), (1,1), wx.EXPAND )
		grille.Add(self.t_instr, (x,y+1), (1,1), wx.EXPAND )
		x += 1
		grille.Add(e_instr_midi, (x,y), (1,1), wx.EXPAND )
		grille.Add(self.t_instr_midi, (x,y+1), (1,1), wx.EXPAND )
		x += 2
		grille.Add(b_voix, (x, 0), (1, 1))
		grille.Add(b_fermer, (x, 1), (1, 1))
		grille.Add(b_portee_ok, (x, 2), (1, 1))

		grille.AddGrowableCol(0)	
		self.SetSizerAndFit(grille)		# mise en place finale
		self.Show(True)					# et affichage
		
	def b_portee_ok_clic(self, ev_b_portee_ok):		# fin de l'ajout d'un nouveau bloc staff
		self.d_port['portee'] = self.t_portee.GetValue()
		self.d_port['clef'] = self.t_clef.GetValue()
		self.d_port['instrument'] = self.t_instrum.GetValue()
		self.d_port['instr'] = self.t_instr.GetValue()
		self.d_port['instr_midi'] = self.t_instr_midi.GetValue()
		self.d_port['liste_dv'] = self.l_voix	# # ############################################
		self.Destroy()
		
	def b_voix_clic(self, ev_b_portee):
		self.fenetre_voix = fen_voix("Voix")
		self.l_voix.append( self.fenetre_voix.lit_voix()	)		# ajout d'une liste de dictionnaire(s)de  voix dans la liste
		
	def b_fermer_clic(self, ev_b_fermer):
		self.Destroy()
		
	def lit_portee(self):
		return self.d_port
##########################################################
##
##  		traitement des Voix
##
##########################################################
		
class fen_voix(wx.Frame):
	def __init__ ( self, titre):
		self. d_voix = {}
		self.l_voix = []
		x = 0	# placement des cellules sur la grille
		y = 0
		wx.Frame.__init__(self, None, wx.ID_ANY, title = titre, pos = ( 300, 300 ) )		# création 
		grille = wx.GridBagSizer()		# création de la grille type tableur : accès direct aux cellules
		self.t_voix = wx.TextCtrl(self, wx.ID_ANY, 'Voix' )		# champ de saisie
		e_voix = wx.StaticText(self, wx.ID_ANY, "nom :" )	# etiquette associée
		self.t_paroles = wx.TextCtrl(self, wx.ID_ANY, "")
		e_paroles = wx.StaticText(self, wx.ID_ANY, "Paroles associées" )
		self.t_notes = wx.TextCtrl(self, wx.ID_ANY, "N" )
		e_notes = wx.StaticText(self, wx.ID_ANY, "Nom mélodie : " )
		self.t_transpose = wx.TextCtrl(self, wx.ID_ANY, "")
		e_transpose = wx.StaticText(self, wx.ID_ANY, "transposer vers : " )
		b_voix_ok = wx.Button(self, wx.ID_ANY , "OK")
		b_fermer = wx.Button(self, wx.ID_ANY , "Fermer")

		self.Bind( wx.EVT_BUTTON, self.b_voix_ok_clic, b_voix_ok)
		self.Bind( wx.EVT_BUTTON, self.b_fermer_clic, b_fermer)
		grille.Add(e_voix, (x,y), (1,1), wx.EXPAND )
		grille.Add (self.t_voix, (x,y+1) , (1,1) , wx.EXPAND )	# ajout des champs  : objet, où (L, C), extension (nb L, nb C), formatage
		x += 1
		grille.Add(e_paroles, (x,y), (1,1), wx.EXPAND )
		grille.Add(self.t_paroles, (x,y+1), (1,1), wx.EXPAND )
		x += 1
		grille.Add(e_voix, (x,y), (1,1), wx.EXPAND )
		grille.Add(self.t_voix, (x,y+1), (1,1), wx.EXPAND )
		x += 1
		grille.Add(e_notes, (x,y), (1,1), wx.EXPAND )
		grille.Add ( self.t_notes, (x, y+1), (1, 1), wx.EXPAND )
		x += 1
		grille.Add(e_transpose, (x,y), (1,1), wx.EXPAND )
		grille.Add(self.t_transpose, (x,y+1), (1,1), wx.EXPAND )
		x += 2
		grille.Add(b_voix_ok, (x, 0), (1, 1))
		grille.Add(b_fermer, (x, 2), (1, 1))

		grille.AddGrowableCol(0)	
		self.SetSizerAndFit(grille)		# mise en place finale
		self.Show(True)					# et affichage
		
	def b_voix_ok_clic(self, ev_b_portee_ok):		# fin de l'ajout d'un nouveau bloc voix
		self.d_voix['voix'] = self.t_voix.GetValue()
		self.d_voix['paroles'] = self.t_paroles.GetValue()
		self.d_voix['notes'] = self.t_notes.GetValue()
		self.d_voix['transpose'] = self.t_transpose.GetValue()
		self.Destroy()
		
	def b_fermer_clic(self, ev_b_fermer):
		self.Destroy()
		
	def lit_voix(self):
		return self.d_voix
		
